﻿
// @name		DisplayImageList for Bookmarklet
// @lastupdate	2013/02/02
// @author		From E@駄文にゅうす(http://ariel.s8.xrea.com/)
// @description	ページ内の画像を一覧表示(http://ariel.s8.xrea.com/news/2012_02.htm#20120212)

(function() { // 無名関数開始

var limitSize     = 32;		// 画像のフィルタリング基準となる大きさを指定。
var thumbnail     = 224;	// 画像一覧表示時のサムネイルサイズを指定。
var safety        = true;	// 画像一覧表示時のリンク先が画像のみ表示なら true 、それ以外(html,cgi,php,asp etc...)も表示するなら false を指定。true 推奨。
var filteringlist = [		// URL指定でフィルタリング(正規表現可) > 文字列中に . / を使う場合は、\. \/ とエスケープする。
	// 画像以外のアンカー
	"mailto:",
	"javascript:",

	// 拡張子指定
	"https?(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)\.(swf|rdf|xml)",	// flash,rdf,xml

	// 画像URL or フォルダ
	"http:\/\/[a-z][0-9]\.twimg\.com\/profile_images\/",
	"http:\/\/d\.hatena\.ne\.jp\/images\/",
	"http:\/\/b\.hatena\.ne\.jp\/",
	
	// 除外するフレーム・インラインフレームのURL
	"http:\/\/www\.youtube\.com\/",				// Youtube
	"http:\/\/ext\.nicovideo\.jp\/",			// ニコニコ動画
	"http:\/\/live\.nicovideo\.jp\/embed\/",	// ニコニコLIVE
	"http:\/\/maps\.google\.co\.jp\/",
	"https?:\/\/plusone\.google\.com\/"
	];



if (document == null) {
	alert("画像一覧を作成できませんでした。");
} else if (document.getElementsByTagName("body")[0] != null && document.getElementsByTagName("body")[0].id == "P0TQRNp0WXy6cee7iVcUNiUOTpPlAf8JbPZUQQD7krO408IoEqpp6T8x50bJwDlC") {
	// 二重読み込み防止
} else {
	var img = document.getElementsByTagName("img");
	var filtering = new RegExp(joinFilteringList(filteringlist), "i");
	var backlink  = '<a href="' + document.URL + '"' + 'title="' + document.title + '"' + 'target="_self" class="return">戻る</a>' + '\n';
	var html      = '';

	for (var i = 0; i < img.length; i++) {
		if (img[i].width > limitSize && img[i].height > limitSize) {
			if( !img[i].src.match(filtering) ) {
				html += parseTag(img[i]);
			}
		}
	}

	if (html.length) {
		preProcessingHtml();

		// 画像一覧を、現在のタブに上書き
		document.title = "about:image - " + document.title;
		document.body.innerHTML = backlink + html + backlink;
		embedStyleSeet();

		window.scroll(0,0);	// ページ先頭へ移動
	} else {
		alert("取得可能な画像はありませんでした。");
	}
}


function preProcessingHtml() {
    // body要素に、二重読み込み検知用のid追加
	var elem = document.getElementsByTagName("body")[0];
	elem.setAttribute("id", "P0TQRNp0WXy6cee7iVcUNiUOTpPlAf8JbPZUQQD7krO408IoEqpp6T8x50bJwDlC");

	// head内要素、全削除
	var node = document.getElementsByTagName("head")[0];
	if (node.hasChildNodes()) {
		while (node.childNodes.length > 0) {
			node.removeChild(node.firstChild)
		}
	}
}



// スタイルシート生成・埋め込み
function embedStyleSeet() {
	var isMSIE = /*@cc_on!@*/false;
	var sheet;

	if (isMSIE) {  // for IE Bbrowser
  		sheet = document.createStyleSheet();
	} else {  // for FireFox, Opera, Safari, Crome
  		var head = document.getElementsByTagName('head')[0];
  
   		if (head == null) {
   			return;
   		} else {
  			var style = document.createElement('style');

  			head.appendChild(style);
  			sheet = style.sheet;
  		}
	}

	if (isMSIE) {  // for IE Bbrowser
		sheet.addRule("body",			"margin:0.5em; padding:0; background-color:#faf0e6;");
		sheet.addRule("img",			"display:inline; margin:5px; background-color:#f0f0f0;");
		sheet.addRule("a img",			"border:solid 3px transparent;");
		sheet.addRule(".return",		"display:block; margin:0 0 1em 0; padding:0.5em 0.5em 0.5em 1em; text-decoration:none; color:#ffffff; background-color:#242424;");
		sheet.addRule(".return:hover",	"color:#ff9900;");
		sheet.addRule(".image:hover",	"border:solid 3px #0068ff;"); // 青
		sheet.addRule(".anchor:hover",	"border:solid 3px #ff8c00;"); // 橙
		sheet.addRule(".html:hover",	"border:solid 3px #ff0033;"); // 赤
	} else {  // for FireFox, Opera, Safari, Crome
		sheet.insertRule("body  { margin:0.5em; padding:0; background-color:#faf0e6; }", sheet.cssRules.length);
		sheet.insertRule("img   { display:inline; margin:5px; background-color:#f0f0f0; }", sheet.cssRules.length);
		sheet.insertRule("a img { border:solid 3px transparent; }", sheet.cssRules.length);
		sheet.insertRule(".return       { display:block; margin:0 0 1em 0; padding:0.5em 0.5em 0.5em 1em; text-decoration:none; color:#ffffff; background-color:#242424;}", sheet.cssRules.length);
		sheet.insertRule(".return:hover { color:#ff9900; }", sheet.cssRules.length);
		sheet.insertRule(".image:hover  { border:solid 3px #0068ff; }", sheet.cssRules.length); // 青
		sheet.insertRule(".anchor:hover { border:solid 3px #ff8c00; }", sheet.cssRules.length); // 橙
		sheet.insertRule(".html:hover   { border:solid 3px #ff0033; }", sheet.cssRules.length); // 赤
	}
}



function joinFilteringList(url) {
	var str = "";

	for (var i = 0; i < url.length; i++) {
		str += url[i];

		if (i != url.length - 1) {
			str += "|";
		}
	}

	return '(' + str + ')';
}



function parseTag(obj) {
	var node  = obj.parentNode;
	var style = setingImagStyle(obj);
	var tag   = "";

	if (node.nodeName == "A" && obj.src != node.href) {
		if ( (node.href).match(/\.(jpe?g|gif|png|bmp)(\?|$)/i) ) {
			tag = '<a href="' + node.href + '"' + 'target="_blank">' + '<img src="' + obj.src + '"' + 'title="' + node.href + '"' + style + 'class="anchor"' + '>' + '</a>' + '\n';
		} else if ( !safety && !(node.href).match(filtering) ) {
			tag = '<a href="' + node.href + '"' + 'target="_blank">' + '<img src="' + obj.src + '"' + 'title="' + node.href + '"' + style + 'class="html"' + '>' + '</a>' + '\n';
		}
	} else {
		tag = '<a href="' + obj.src + '"' + 'target="_blank">' + '<img src="' + obj.src + '"' + 'title="' + obj.src + '"' + style + 'class="image"' + '>' + '</a>' + '\n';
	}

	return tag;
}



function setingImagStyle(img) {
	var width,height;

	if (img.width > thumbnail || img.height > thumbnail) {
		if (img.width > img.height) {
			width = thumbnail;
			height = img.height / (img.width / thumbnail);
		} else if (img.width < img.height) {
			height = thumbnail;
			width = img.width / (img.height / thumbnail);
		} else {
			width = thumbnail;
			height = thumbnail;
		}
	} else {
		width = img.width;
		height = img.height;
	}

	return 'style="' + 'width:' + Math.round(width) + 'px;' + 'height:' + Math.round(height) + 'px;' + '"';
}

})();	// 無名関数終了